# Spingle Installation

To compile Spingle, you will need:

- Any reasonably new C compiler
- pkg-config (any version)
- CMake (>=3.14)
- SDL2 (>=2.0.0)
- OpenGL (1.0 or newer, 1.3 for shaders)

For FLAC support:

- libFLAC (>=1.3.3)

For Ogg Vorbis support:

- libvorbis (>=1.3.6)
- libvorbisfile (>=1.3.6)
- libogg (>=1.3.4)

For Ogg Opus support:

- libopus (>=1.3.1)
- libopusfile (>=0.11)
- libogg (>=1.3.4)

For tracker music support:

- libmikmod (>=3.3.11)

To generate build files:

```
mkdir build
cd build
cmake .. -DCMAKE_BUILD_TYPE=Release
```

After that, use the generated build files to compile. (For Makefiles simply run
`make`, for Ninja use `ninja`, etc.)
