/*
Copyright (C) 1996-2001 Id Software, Inc.
Copyright (C) 2002-2009 John Fitzgibbons and others
Copyright (C) 2010-2014 QuakeSpasm developers
Copyright (C) 2019 Alison G. Watson

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

#ifndef spingle__pr_defs_h
#define spingle__pr_defs_h

enum
{
	DEF_SAVEGLOBAL = 1 << 15
};

typedef enum
{
	ev_bad = -1,
	ev_void = 0,
	ev_string,
	ev_float,
	ev_vector,
	ev_entity,
	ev_field,
	ev_function,
	ev_pointer
} etype_t;

typedef int32_t func_t;
typedef int32_t string_t;
typedef uint32_t pedict_t;
typedef uint32_t pfield_t;
typedef uint32_t prptr_t;
typedef void (*builtin_t)(void);

typedef struct
{
	uint16_t type; /* if DEF_SAVEGLOBAL bit is set the variable needs to be saved in savegames */
	uint16_t ofs;
	int32_t  s_name;
} ddef_t;

typedef union eval_s
{
	float    flt;
	vec3_t   vec;
	func_t   func;
	int32_t  _int;
	pedict_t edict;
	pfield_t field;
	string_t string;
	prptr_t  ptr;
} eval_t;

#endif
